/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package com.ebmwebsourcing.jbi.adaptor.impl;

import com.ebmwebsourcing.easycommons.lang.UncheckedException;

/**
 * @author Marc Jambert - EBM WebSourcing
 */
public enum ComponentType {

    BC_FILETRANSFER("org.ow2.petals.bc.filetransfer.FileTransferComponent"),
    BC_FTP("org.ow2.petals.bc.ftp.FTPComponent"),
    BC_MAIL("org.ow2.petals.bc.mail.MailComponent"),
    BC_SFTP("org.ow2.petals.bc.sftp.SFTPComponent"),
    BC_SOAP("org.ow2.petals.binding.soap.SoapComponent"),
    BC_SQL("org.ow2.petals.bc.sql.SqlComponent"),
    
    SE_BPEL("org.ow2.petals.bpel.engine.BPELEngine"),
    SE_EIP("org.ow2.petals.se.eip.EIPComponent"),
    SE_JSR181("org.ow2.petals.se.jsr181.Jsr181Se"),
    SE_QUARTZ("org.ow2.petals.se.quartz.QuartzSe"),
    SE_VALIDATION("org.ow2.petals.se.validation.ValidationSe"),
    SE_XSLT("org.ow2.petals.se.xslt.XsltSe");
    
    private final String className;
    
    ComponentType(String className) {
        this.className = className;
    }
    
    public final String getClassName() {
        return className;
    }

    public static final ComponentType fromClassName(String className) {
        for (ComponentType componentType : ComponentType.values()) {
            if (className.equals(componentType.getClassName())) {
                return componentType;
            }
        }
        throw new UncheckedException(String.format("Unknown component type for class '%s'", className));
    }

}
